'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise;

function _load_promise() {
  return _promise = _interopRequireDefault(require('babel-runtime/core-js/promise'));
}

exports.hasWrapper = hasWrapper;
exports.run = run;

var _util;

function _load_util() {
  return _util = require('../../reporters/console/util.js');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const chalk = require('chalk');

const guy = ["                                               `                  `", "                                                   `              `   `", "                                              ``.```    . ``      `  `. `", "                                              ``````` ` ` `   ` . .  ``", "                                              ```. `.```.   ... ``..```` `", "                                      `  `   `` .`.`` ..`.``....`.`.`....` .", "                                      ` ..`  `. ..``.`....``....```.....``` `", "                                `    `.  ``.``.`.````.`.```...`.....``...````", "                                    ` .  ...`,..`..```...``.````. `.```.`` .`", "                                 .`  .````....`.````````````````````.````` ``", "                                . .` ``.`.`.``````````````````.``````````  `   `", "                               `.`` .```..`.````````````````````````````` `````", "                                `.` ...```.`````````````````````````````.``.`...", "                             ` ``..``````````````````````````````````````.`.``.`   `", "                              ``````.`````````````````````````````````` ``..```  `.", "                               ``..``````````````` .````````````````````.`..``` . `", "                         .`  `` .`.``.```.``````````.```````````````````.``...`.  `", "                          .``` .`.```````````````````````````````````````````.`. ``", "                         ` ```` ....````````````..````` ```````````````````````.`.  `", "                         ` ````..``````` ```````.`````` ````````` `````````..`..`.", "                        . ` `.  ``.```````````````````` ```.````` `````.```.``..`. .", "                         ` ``` `````` ``````````.``````````.````````.``.```.``..`.```", "                        `` ``.   ````````` ``````````````..`````````.```. `````.`..``", "                       `````.` ` ``````````.` ` ````````````````.` `.``.`````````. `.", "                       `   `.`  `````` ````.```````````````.`.```````````````````.``.`", "                     ```   `.````````` ``` ``````````````````````````````````````...``", "                      ```    `.`````` `````````.``````.````.``````````````````````.``.", "                      `.` `.`  ````````````.````````.`````````````````````` ````````.`", "                       ` ` ```   ``` ```  `.``````````.```.`..``..``.``````  `````.`..", "                        ``````. `````` `` ``````.``.``.`````..``````.````.`` ``````... `", "                        ```````..```````` ````.`.```````````..````````.```````````..``", "                        `.````` ` ````` `  `````.``.``````....``````.`.`..````````.```..", "                        `````.````  ``` ``  ````````.````.``..`.` ````.`.``.`````````.``", "                     ` `` `.`.`` `     ` ` ```.`````````````.``.``.`.`...``....``````.` `", "                       ``..```````` ` `. ``````...`````````````.`.`.`.....,,....````..`", "                      `.`,``````.```   `` ` .```..`````````.```````..,,...,,,,...```````", "                      `.`.`` ```````   ``````.`````````````````..`........,,,,...`````.````", "                       `.``.```````` ` ``.`..``.`....````````............,,,,,,..`````.", "                     ` ...`````````` `````.`.......`````````..`..`.......,,,,,,.`..`.`. `", "                      ``..`````````````.`..........`````````````........,.,,,,,........`", "                      ``````````````````.............````````````........,,,,,,.`.......", "                      .````. ``` `` `.....``.......`.````````````........,,,,,,,.....`.`", "                      `` `` ```` `````.............``````````````.......,,,,,,:,.......``", "                       ``.``  ``` ````................``````````.......,,,,,:,,,...`...`", "                     ` .`````  ``.````................`````````........,,.,,:,::,......`", "                     ``````````` `````.................```````.........,,,,,:,,:..`..,.`", "                      ```.``````` ```....................```..........,,,,,,,,::,.`.....`", "                      . `.``````..````.......,............``.........,,,,,,,,,,:,...,...", "                      `.  ``````.`.````.,.............................,,,,,,,:,:,....,..`", "                       `. `````..`.````.,...,........................,,,,,,,,,,::,...,..", "                      ``.``````....```..,,.,,,,......................,,,,,,,,,:::,,.,,.`", "                      `````````.``.```...,.,,,,,....................,,,,,,,,,,,::,,,.,,`", "                       `.``.`.``..``.....,.,..,,,....................,,,,,,,,,,:::,.,.,,", "                       .```.`..``.```.``.,.,,.,,,,,..................,,,,,,,,,,:::,,.,,`", "                      ` .```.........``..,,,,,,,.....................,,,,,,,,,,:::,,..,`", "                      `` `.````,`,`.```..,,,..,,,.......................,,,,,,,,:::,..,", "                       `````````.`..``...,,,.,,,........................,.,,,,,,:::;,.,.", "                       .`....````,..`.`.,,,,,,,,,........................,,,,,,::::',.,.", "                       ```.... ``.`..`.`,,,,,,,,.,.......................,,,,,,::::;:,,.", "                       ```.,..` ```.. `..,,,,,,,,.,......................,,,,,,,:::;;,:;.", "                       ``...,,,..``.`.`..,,,,,,,,.......................,,,,,,,:::::;,.;`", "                        ````,,.,,..`.`...,,,,,,,,..........`..........,,,,,,,,,,::::;,.:`", "                         `.``...`..```.`.,,,,,,,,....................,,,,,,,,,::::::;:,;.", "                         `.``.`.,``...`.,,,,,,,,,...................,,,,,,::;;;';;::::,;,", "                         ......`````...,:,,,,,,,,,..............,,,,,,:::'''''''''::::,:,", "                         `.....,.......,,,,,,,,,.,,......,,...,,,,,,::;;'++++++''';:::,,,", "                        `..````.......,:,,,,,,,,..,..,...,,,,,,,,,,,:;'++##++''';;;:::,,.", "                          ..``..`..,,:,,,,,,,,,,...,,,..,,:,,,,,,,,,:;'+++'';;;;::;::::.`", "                         `..,.`..,..,,:,,,,,,,,,,,.,,,::::::::,::,,:;'''';;;;;;;:::::::,`", "                         `.,,..,,,...:,,,,,,,,:,::::;;''';;::::,::::;;'''+####++;::::::,`", "                         ``.,:,,,.`..,,,,,,,,,::;;;''+++''';;::,,,,:;''++#@@@####;:::::,.`", "                          .,:;,,,,.:.:,,,,,,,:;''''++++++';;;::,,,:;'+'''@'@@#+++';::::,,", "                          ..';',,.:.,,,,,,,,:;;'''+''+';;;;;;;:,,,:;'+'###+';'';;'::,:::.", "                           `:::;:,,...,,,,,,;;'''';;:;;;;;;;;;:,..,;+##';;:;;;::::::,,::`", "                           ,::,,::....,.,,,,;;;;;;:::'#++;;;;;:...,;++';;:::::::;:,:,::;`", "                           ,;;:,,.....,,.,,:;;;;:;;+@@@'+'';;':.`.,:''';:::::::;:,,,,::;", "                           .;;':::....,,,,,:;;;;;+##@@#+###'';:.`..,;;;;;;;;;;;;:,,:,,:;", "                           `;;+':,....,,..,:;;;;###@+#+'';;:;::.`..,,;:::;;;;;:.,,:,:::;`", "                            ;;'';,,....,,,,,:;;+++';::;;::;;;,:....,,,::,,,:,,...,,::::;,", "                            :;;'',..,...,,,,:;;;,:,,:,::;;;::,,......,:,,,.......,,,::,;:", "                            :';;':....,,,,::::;:,,,,,,:;;;:::,.....,.,,,,........,,,::,;:", "                            .;:;;:.,,,,,,,,:,.,,:,,:::;;::,:,,......,,,,,........,,,,:,;:", "                             :;;;;,..,,,,,,...,.,:::;;;;:,,,,...``..,..,,........,,,,:,;:", "                             :;;::,,,,,,,,,..,.,,::;;::,.,,,,...```..,,:,,........,,,,,:;", "                             .:::;:.:,,,,,,,,.,,............,..`.``.,,:;:,,.......,,,,,:;", "                              ,:::;:,:,,,,,,,.....``.`.........````..,;'';,......,,,,,,,:", "                              :;,:;::,,:,,,,......````.`....,,,.```..,;;'',,,,,,.,,,,,,,'", "                              ,:.:;:::,,,,,,.....````````...,:,,````.,;,,#':,,,,,,,,,,,,.,", "                               ,,:;:;:::,,,,,....`````````.,:::,.```.,,.,:+;:,,,,,,,,,,,.,", "                               ,:,,::::,:,,,.....````````.,:,,:,..``..,..,'';:,,,,:::,,:,`", "                               ,,:,:::::,,,,......``````..::...,..``..,,,,'';;,,:,:::,::,`", "                               ,.:,,::::,,,,.............,;:......```.,,,,''';:,::::::::,,", "                                ,.,,::::,,,,............,:;:......``..,,,,''';::::::;::::'", "                                ,..,::::,,,,,..........,:;::.........,,.:#''';;:::;;;;;;;`", "                                ,.,,:::,,,,,..........,:;;::,,,,,...,,:;##';'+;:::;;;;;;:", "                                `..,::::,,,,,,,.......::;;:::::::,,,,:;###':;+':::;;;;;;:", "                                 ..,::::,,,,,,,,,....,:;';::''';:::::;'##+;';'+;::;;;;;;:", "                                 :,,:::,,:,,,,,,,,...,:;;:::;'++';;;;;##+#''+++;;;;;;;;;,", "                                  ,,:::,,,:,,,,,,,,,,:;';;:;;+##++'''###++++'++';;;;;;;;.", "                                 `.:::::,:,:,::,,,,,::;';;;;;'+#+##++###++''++++;:;;;';;`", "                                 . `,:::::::::::::,,::;'';;;;'++++#+'+#+++':'+++;::;;;;;", "                                 ,  '::::::::::::::::;'''';;;''+++##'++'+';;++++;::;;;;'", "                                 :  +:::::::::;::::::;'+';;';'+++++++++''''#+'++;:;;;;;'", "                                 .  +:;::::::;:::;::;'+++''';'''+'++';;'';@#++++::;;';;:", "                                  :.+;;;:::::::;;:::;'+++''':;;;'';;;'';,;@#++++;:';;;'`", "                                  ,::;;;::;:::::;:::;++++''';;;;;;''';;::@##+'++;:;';;'", "                                   ':;;;;;;:;:;;;:::;+++#@;,,:,,,,.:.,::@@#+';'+:;;;;;'", "                                   #@';;;;:::::::;:::'+#+#@;,,.,.,`:,,'#@#+';;'+;;;;;',", "                                   +#:;;;;;;::::;::::;++'##@@#+#::.,'#####+';;'+'';;;'", "                                   ;@,;;;;;;;::;;:::::++';+#####++######++';;;;+''';;'", "                                   #@;';;;;;;::::::,,:;+;::'+##++++#+'#+'';;;:;++';;;,", "                                  `##@+;;;;;;::::;::,,;+::::;;'++''+++'';;;;;;;++'';;#@+", "                                  .;@#:';;';;:::::::,,;+;::,:::;;;'';;::;:;;:;;++';''@@@@@@@:`", "                                  ,+@@,';;;;;;::::;:,,;+;,,,,::,.,::,,:;;::::;;++';;'@@@@@@####@#;,;,`", "                                  ,+#@+';;'';;;:::::::;+;:,::,::,,..,::;;::::;'++';;'@@@@@@@@@@#######@@@:`", "                                  ,+###,';;'';;::::::,:+::,,::,::,,,,::;::::::;++';;'#@@@@@@##@##@@@@######@:`", "                                  .+;##:';;'';;;::::::;+',,,:::,,,,,:::;,:::::'++';''@@@@@@@@###@#############@;  `", "                                  .'+#@#;;;;;;;;::::;::+':,,,,::,,,:,::,:,,:::'+#;;;'@@@@@@@@#####################@@", "                                  .':;@#,';;'';;:::;:::+'::,,,:::,,::,,...,,::'+#;;;'@@@@@@@@#######################@", "                                  `+@;+##'';;;;;:::::;;+'::.,,,,..,,,...,,,:::'+#';;'@#@@@@@#@#######################@", "                                  ;#@#'#@:';;;;;;;::::'+':,,,,,,....,....,,,::'+#';;'@#@@@@@#@########################+", "                                 ',+##+'@#:';;;;;:::::;++:,,,,,..,....,...,:,;'+++;;'@+#@@@@@@@########################'", "                                `#;+#+#++#++;;;;;::::,;#'',...,...,,,..,`.,,:;++#+;;'@##@@@@###@########################'", "                                ###:#'#+;@':+;;;;;::::;++':,.............,,,,;'###;;'@##@@@@@##@#########################'", "                               #### #'##+@@',';;;;:::::#+;:,,.......`....:,.:;+##+';'@#@@@@@@###@#########################+", "                              :####+:+@#+###+:;;;;;::,;+++;,,.,`,....`...,:,:'+#++;;+##+@@@@@##############################+", "                              ###### ##'###@##;;;;;:::'##+':,,...`....,,.,:,;;###+';#:@##@@@@###############################+", "                             +#######,#@###@@+#;;;;;:::+#+'::,..,,...,..,:::;'#+++';+:##+#@@@#################################", "                            .########.#@###@@#'@;;;;;;;+##+;::,.,,.,..,,.,:;;+#+##+'+#+@'#@@@##################################", "                            ########## @#@#@@##'@;;;;'++#++';;:,,,,,,,,,:,:'+##+#+''##,@;@@@@##################################.", "                           ############,@###@@#++#;;;;'####''';:,,,,.,.,,:;'++###'';#@,#'@@@@@##################################", "                          .###########'.#####@##+##;'+######++';;,,.,,.,.;;'+#++''';#@;+@@@@@###################################.", "                          @##########';;`#@##@@##'@#'+#####+##+';;,,,,,,.;+++++'''';#@@;+##@@####################################;", "                         ###########+;;;;;####@#''#@##########+#+':,.,:,,;++#+''''''+@@,#+#@@####################################@.", "                        +##########+;;;;;;#@###@+''##############;;:,.::::+#''''''''+##:#;#@@####################################@#", "                       :###########;;;;;;;;@###@@+'@@###+#+######'',,.:,;:++';'''';++@#+;:@@@@###################################@#,", "                       ###########;;;;;;;;;;##@#@#'###@@#+++###+++'::,,,'';''''''''++#++.:#@@#######################################", "                      +##########+;;;;;;;;;;:#@#@@++##@@@#@++####+';,,,,,;''''''''++'#;;@;@@########################################", "                     `########+##;;;;;;;;;;;';###@#+##@@@@@;+';'+++;:,.,,;'''''''+++'##;#'@#@####################################@##", "                    `###########+;;;;;;;;;;;;:'#@#@#+#@@@@@:#';;;;';:,,,:''''''''++''+#:####@####################################@##", "                   .############;;;;;;;;;;;;;;,+#@###+@@@@@;#+';''';;;:,:''+''+'+++'++@@'###@#######################################,", "                  `###########+';;;;;;;;;;;;;;;,'##@###@@@@#++'''''';,:,;'++++++++'''+#;;@##@@######################################@", "                  ##########++#;;;;;;;;'';;;;;;','#@@###@@@@'#+''''';:::++++++++++'+'+;:,@##@########################################,", "                 +############;;;;;;;;;''';;;;;;'.:#@###@@@@:#++''''';:+'####++++++'''#+.###@@######################################++", "                 #########@###;;;;;;;;;;''';;;;;'',,#@###@@@:#++++++++##########+++'';+':#@#########################################+'.", "                '##+######@@@#;;;;;;;;;;;''';;;;;';,`#####@@'##+++++###########+++''';+:;@##@########################################''", "                ####+#######@#';;;;;;';;;;''';;;;;'':`##+#@@#+#################+++'';;#'########################################@#####'", "               :##############'';;;;;;;';;'''';;;;''';`:#+##@;#################++''';;+'###############################################:", "               ###########+###;'';;;';+;::,;''';;;;''''.`@##@,@##@@@@@@#########++';;;;,@######################################@#######:", "              #########+#+##++;'';;';;;''';;;''';;;;'''';`.@+.@@#@@@@@@@#######++''';;',###############################################+.", "             `#########++####;;;'+';;'';:;';'##+';;;'''''';`.,@@@@@@@@@@######+++'';;;+;################################################.", "             ###########+++#';;;;'';;;#':+,';+#'+';;;''''''';.`#@###@@@@######+++';;;;'#################################@###############'.", "            ;#############'';;;;;;;;;'+++;:+;,+#'';;;;''''''''+:`:+@##########++''';;;,@################################################+.", "            #############;;;;;;;;;;;;:'#+++;',,:#''';;'''''''''''+':,:+#@#####++'''';;.@###############################################'+'`", "           #############;;;;;;;;;;;;;;;+#;+++';;;++';;;''''''''''''++++;,;@##++''''';;:@################################################''`", "          .##########+#;;;;;;;;;;;;;;;;;#;+'#+';'#'+';;;''''''''''''''++++'.'++''''';;'@################################################;'`,", "          ###########++;;;;;;;;;;;;;';;;'+'++';,;'#''';;;'''''''''''''''+++++::'''';';#@##################################@####@########''`;:", "         ;#########@##;;;;;;;;;;;;;;;';;'+#+###'::;'+';;;''''''''''''''''++'''+::'';;,@##################################@##############+''. `", "         #####@@###+#;;;;;;;;;;;;;;+:+++''#####++::''+';;;''''''''''''''''''''''':;;;.###################################@@##############'''.", "        '###@@######';;;;;;;;;;;;;;#+##+''######'+;'++'';;;;''''''''''''''''''''''':'.#@@################################@@##############'''+@.", "        ###@@#######;;;;;;;;;;;;;;;;+##+''#######+':''+';;;;'''''''''''''''''''''''+:,##@################################@@##############+''+;,", "       '#@@####@@@@@;;;;;;;;;;;;;;;+++''+++###+;;#++:;''';;;;;''''''''''''''''''''''+;#@@################################@@###############''';'", "       #@########@@@#;;;;;;;;;;;;;;'''''#++++#++@;+++;:+';;;;;''''''''''''''''''''''+'@@#################################@@################'#+#`", "      ,@@###########@+;;;;;;;;;;;;;;;;;++'+++;:#'#;'++;'+';;;;;;'''''''''''''''''''''##@#################################@@#################++#:", "      #@#############+';;;;;;;;;;;;::::;+'+++;,#+#'++';''';;;;;;;''''''''''''''''''+;##@#################################@@##################'''", "      @#############;;;';;;;;;;;;;;:::;+##'+';;+#@+@+#:;''';;;;''''''''';''''''''''':##@##################################@###################''", "     +##############;;;;';;;;;;;;;;:::,'###'+;''++@#+##;''';;;;''''''''';;''''''''''.##@##################################@#################@#+'.", "     @##############;;;;;';;;;;;;;;:,::;###++;':'+';++##;''';;;''''';;''';';''''''''`##@##################################@################@###';", "    ;##############+;;;;;;;;;;;;;;;::,,;+####'',''+##+#';;'';;;;''''';''';;;''''''''`##@##################################@#############@##@####'", "    @#############++;;;;;;'';;;;;;;:,,,:'##+#'+''''+#+#+;;;+';;;''''';;'';;;''''''''.##@@#################################@###############@#####+,", "    ###############';;;;;;;';;;;;;;:,:,,;++'###+:'''#;###;;'+;;;;;'''';;;;;;'''''''',#####################################@@##@##########@@######'", "   :##############+;;;;;;;;;';;;;;;:,,,::+#@####;'''';##+;;'+';;;'''''';;;;;'''''''''###@##################################@##@##########@########", "   @###############;;;;;;;;;;';;;;;;;::,,;+###'#+,'';'##+;;;'+;;;;;'''''';;;''''''';+###@##################################@##@#########@@########:", "   ################;;;;;;;;;;;;;;;;;#;:,,:+##+@##;'+:''#;';;''';;;''''''''''''''''',####@##################################@##@########@@##########", "  `###############+;;;;;;;;;;;';;;;;;;':,,;+##+;##';+'',#;;;;'+;;;;''''''''''''''''.####@##################################@##@########@###########", "  ,#############+#+;;;;;;;;;;;;';;;;'#:;,,:;##;####+'+''++:;;''';;;;;'''''''''''''' #######################################@##@#######@@###########,", "  ###############';;;;;;;;;;;;;;';;;;'#'';;#':'#;##+++'',+;;;;'+;;;;;''''''''''''''`#######################################@##@#######@############'", "  @##########@;;;;;;;;;;;;;;;;;;;';;;''+':::'+#:@###++;+;'';;;''';;';'''''''''''''':#####@#################################@#@#######@############+;", "  ##########+;;;;;;;;;;;;;;;;;;;;';;;';,:',;#+#++'###+:'';;';;###;;;;';''''''''''';'#######################################@@@####################+',", " `########@'';;;;;;;;;;;;;;;;;;;;;';;:';;;:#+;';'@+@#++;+::;;;@##';;;;;''''''''''':######@#################################@#@######@##############'+", " ;#######@;;;;;;;;;;;;;;;;;;;;;;;;;';;:'''''##'#+,#'';+:'+':;;+##+;;;;;'''''''';''`######@#################################@@@@####################'+", " @#######;'';;;;;;;;;;';';;;;;;;;;;';;',;,+,;###;+;####+'+':;'+##+';;;''''''''''''`######@#################################@@@#####################';`", " #######;;'';;;;;;;;;;;'''';;;;;;;;'';',,'':'+###;@:##;;++::;+###++;;;''''''''''''.#######@################################@@@######################;:"];

const COLORS = ['red', 'green', 'yellow', 'blue', 'magenta', 'cyan', 'white'];

function randomColor(line) {
  let colorLine = '';
  for (let char of line) {
    if (char) {
      const color = random(COLORS);
      char = chalk[color](char);
    }
    colorLine += char;
  }
  return colorLine;
}

function random(arr) {
  return arr[Math.floor(Math.random() * arr.length)];
}

function hasWrapper() {
  return false;
}

function run() {
  for (let line of guy) {
    console.log(randomColor(line));
  }
  return (_promise || _load_promise()).default.resolve();
}